
import javax.swing.JComponent;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Frame;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Canvas;

public class AWTImageViewer implements ActionListener {
    public static void main(String[] args) {
	String filename = null;
	try {
	    filename = args[0];
	} catch (ArrayIndexOutOfBoundsException aioobe) {
	    System.err.println("AWTImageViewer: image file name missing");
	    System.err.println("Usage: AWTImageViewer jpeg_image_file");
	    System.exit(1);
	}
	new AWTImageViewer(filename);
    }

    AWTImageViewer(String filename) {
	
	Frame frame = new Frame("Image: " + filename);
	frame.setBackground(Color.blue);
	ImageComponent imageC = new ImageComponent(filename);
	frame.setBackground(Color.gray);
	
	frame.add(imageC, BorderLayout.CENTER);
	
	JButton quitButton = new JButton("Quit");
	quitButton.getModel().addActionListener(this);
	
	frame.add(quitButton, BorderLayout.SOUTH);
	frame.pack();
	frame.setVisible(true);
    }

    public void actionPerformed(ActionEvent event) {
	System.exit(0);
    }
}

class ImageComponent extends Canvas {


    String filename;
    Image image;
    
    Image getImage() {
	if (image == null) {
	    image = getToolkit().createImage(filename);
	}
	return image;
    }

    public ImageComponent(String filename) {
	this.filename = filename;
	getImage();
    }
    
    public void paint(Graphics gfx) {
	gfx.drawImage(getImage(), 0, 0, this);
    }

    public Dimension getPreferredSize() {
	Image img = getImage();
	return new Dimension(img.getWidth(null), img.getHeight(null));
    }
    
    
}

    
