package java.awt.peer;
import java.awt.*;
import java.awt.image.*;

public interface ComponentPeer {
    
    Toolkit getToolkit ();
    Graphics getGraphics();
    Dimension getMinimumSize();
    Dimension getPreferredSize();
    GraphicsConfiguration getGraphicsConfiguration();

    void setBounds (int x, int y, int w, int h);
    void paint(java.awt.Graphics graphics);
    void setVisible(boolean visible);
    void setForeground(Color color);
    void setBackground(Color color);
    void setFont(Font font);

    void processEvent(AWTEvent awtevent);

    void repaint(int x, int y, int w, int h);

}
