package no.rwr.util;

public class BitMaskExtent {
    public byte leastSignificantBit;
    public byte bitWidth;

    public void setMask(long mask) {
	leastSignificantBit = 0;
	bitWidth = 0;
	if (mask == 0) return;
	long shiftMask = mask;
	for (; (shiftMask&1) == 0; shiftMask >>>=1) leastSignificantBit++;
	for (; (shiftMask&1) != 0; shiftMask >>>=1) bitWidth++;

	if (shiftMask != 0)                                       // ASSERT
	    throw new IllegalArgumentException("mask must be " +  // ASSERT
					       "continuous");     // ASSERT

	if (toMask() != mask) {                                   // ASSERT  
	    String msg = "mask calculation is wrong: mask=" +     // ASSERT
		mask + " gives leastSignificantBit=" +            // ASSERT
		leastSignificantBit + ", bitWidth=" + bitWidth +  // ASSERT
		", which gives mask=" + toMask();                 // ASSERT
	    throw new InternalError(msg);                         // ASSERT
	}                                                         // ASSERT
    }

    public long toMask() {
	return ((1<<bitWidth)-1) << leastSignificantBit;
    }
    
}
