package no.rwr.x;

import java.awt.Rectangle;

public class ClientMessageEvent extends XEvent {

    public ClientMessageEvent(XAnyEvent event) {
	super(event);
	// FIXME: Avoid double checking?
	if (event.getType() != XAnyEvent.TYPE_CLIENT_MESSAGE) {
	    throw new IllegalArgumentException("Wrong event type");
	}

    }

    public native int getMessageTypeAtom();
    public native int getFormat();

    public native byte getByte(int i);
    public native short getShort(int i);

    // X calls this a long, but it is only 32 bits.    
    public native int getInt(int i);

    public String toString() {
	Display display = event.display;
	return getClass().getName() +
	    "[xevent=" + event +
	    ",type=" + display.getAtomName(getMessageTypeAtom()) +
	    ",format=" + getFormat() + "]";
    }
}



